#include "ips_audio_alsa_ALSATargetDataLine.h"

//JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSATargetDataLine_open(JNIEnv *env, jobject obj,jint cardNumber,jint devNumber,jstring type,jint channels,jint samplerate,jint frameSize,jint bits,jboolean s,jboolean bigEndian){
//
//
//	//const char *msg_t=&msg;
//	//jsize typeLen=(*env)->GetStringLength(env,type);
//	jboolean iscopy;
//	const char *devTypeC= (*env)->GetStringUTFChars(env,type, &iscopy);
//	// Estimate device name length. Uhhhh. Dirty.
//	//int maxDevLen=typeLen+1+100+1+100;
//	//char *devName=(char*)calloc(maxDevLen,sizeof(char));
//	char devName[MAX_MSG_LEN];
//	snprintf(devName,MAX_MSG_LEN,"%s:%d,%d",devTypeC,cardNumber,devNumber);
//	dataline_t* dl=getDataline(env,obj);
//	openPCMDevice(env,obj,dl,devName,channels,samplerate,frameSize,bits,s,bigEndian);
//}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSATargetDataLine_open(JNIEnv *env, jobject obj,jstring devNameJ,jint hardwareChannels,jint channels,jint samplerate,jint frameSize,jint bits,jboolean s,jboolean bigEndian,jboolean blockingMode,jint bufferSize){

	jboolean iscopy;
	const char *devName= (*env)->GetStringUTFChars(env,devNameJ, &iscopy);
	dataline_t* dl=getDataline(env,obj);
	if(DEBUG>0)printf("Open PCM Device %s\n",devName);
	char msg[MAX_MSG_LEN];
	//dataline_t* dl=&datalines[cardNumber][devNumber][0];


	dl->framesTransfered=0;
	dl->frameSize=frameSize;
	dl->channels=channels;
	int sampleSize=frameSize/channels;


	snd_pcm_format_t format=snd_pcm_build_linear_format(sampleSize*8,bits,!s,bigEndian);
	if(format==SND_PCM_FORMAT_UNKNOWN){
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),"Unknown audio format");
		return;
	}
	unsigned int captureChannels=channels;

	unsigned int captureFrameSize=frameSize;

		if(hardwareChannels>0){
			if(channels>hardwareChannels){
					snprintf (msg,MAX_MSG_LEN, "Requested channel count (%d) is greater then available hardware channels (%d)\n",channels,hardwareChannels);
					(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),msg);
					return;
			}
			captureChannels=hardwareChannels;
			captureFrameSize=frameSize*hardwareChannels/channels;
		}

		int preferredBufferSizeFrames=-1;
			int prefBufferSize=bufferSize;
			if(prefBufferSize>0){
				preferredBufferSizeFrames=((prefBufferSize *captureChannels)/channels)/captureFrameSize;
			}
	int mode=0;
	if(!blockingMode){
		mode=SND_PCM_NONBLOCK;
		if(DEBUG > 2)printf ("NONBLOCK mode open\n");
	}
	int ret=snd_pcm_open(&(dl->pcm),devName,SND_PCM_STREAM_CAPTURE,mode);

	if(ret<0){
		snprintf (msg,MAX_MSG_LEN, "Cannot open audio line %s (%s)\n",devName,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;
	}
	if(DEBUG>0)printf("PCM Device %s opened.\n",devName);

	/*else{
		// query supported channels
		snd_pcm_hw_params_t *hw_params;
		snd_pcm_hw_params_alloca(&hw_params);
		ret = snd_pcm_hw_params_any(dl->pcm, hw_params);
		if(ret==0){
			unsigned int min_channels;
			ret=snd_pcm_hw_params_get_channels_min(hw_params,&min_channels);


			if(min_channels>channels){
				captureChannels=min_channels;
			}else{
				captureChannels=channels;
			}
			printf("Min Channels: %d capture channels %d\n",min_channels,captureChannels);
			fflush(stdout);
		}else{
			snprintf (msg,MAX_MSG_LEN, "Cannot open audio line %s (%s)\n",devName,snd_strerror (ret));
			(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
			return;
		}
	}*/

	// Fixed audio format for now
	//snd_pcm_t *pcm=dl->pcm;


	if ((ret = snd_pcm_hw_params_malloc (&dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot allocate hardware parameter structure (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;

	}

	if ((ret = snd_pcm_hw_params_any (dl->pcm, dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot initialize hardware parameter structure (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_access (dl->pcm, dl->hw_params, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set R/W interleaved access type (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_format (dl->pcm, dl->hw_params, format))< 0) {
		snprintf (msg,MAX_MSG_LEN, "Invalid sample format (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;

	}
	if ((ret = snd_pcm_hw_params_set_rate(dl->pcm, dl->hw_params, samplerate, 0)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set sample rate %d (%s)\n",samplerate,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_channels (dl->pcm, dl->hw_params, captureChannels)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set set channel count to %d (%s)\n",captureChannels,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params (dl->pcm, dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set parameters (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}
	snd_pcm_uframes_t bs;
	ret =snd_pcm_hw_params_get_buffer_size(dl->hw_params,&bs);
	snd_pcm_uframes_t bsMin;
	snd_pcm_hw_params_get_buffer_size_min(dl->hw_params,&bsMin);
	snd_pcm_uframes_t bsMax;
	snd_pcm_hw_params_get_buffer_size_max(dl->hw_params,&bsMax);
	if(DEBUG>2)printf("Buffer size frames min: %lu max: %lu  normal: %lu\n",bsMin,bsMax,bs);

	//unsigned long prefBufferSizeFrames = 8 * 4 * 44100;

	//unsigned long maxBufferSizeFrames=prefBufferSizeFrames;
	//unsigned long minBufferSizeFrames=prefBufferSizeFrames;
	unsigned long bufferSizeFrames=preferredBufferSizeFrames;
	/*
	snd_pcm_hw_params_set_buffer_size_min(dl->pcm,dl->hw_params,&minBufferSizeFrames);
	snd_pcm_hw_params_set_buffer_size_max(dl->pcm,dl->hw_params,&maxBufferSizeFrames);
	snd_pcm_hw_params_get_buffer_size(dl->hw_params,&bufferSizeFrames);
	printf("Buffer size frames pref max: %ld max set: %ld\n",prefBufferSizeFrames,maxBufferSizeFrames);
	printf("Buffer size frames pref min: %ld min set: %ld\n",prefBufferSizeFrames,minBufferSizeFrames);
	 */
	if(preferredBufferSizeFrames>0){
	if(DEBUG>2)printf("Try to set buffer size frames: %d\n",preferredBufferSizeFrames);
	ret=snd_pcm_hw_params_set_buffer_size_near(dl->pcm,dl->hw_params,&bufferSizeFrames);
	}
	if(DEBUG>2)printf("%d, %s: Buffer size frames set: %lu\n",ret,snd_strerror (ret),bufferSizeFrames);
	if(DEBUG>0)fflush(stdout);


	if ((ret = snd_pcm_prepare (dl->pcm)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot prepare audio line %s (%s)\n",devName,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}
}

JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSATargetDataLine_nRead(JNIEnv* env, jobject obj,jbyteArray buf,jint offset,jint len){

	jint read=0;

	dataline_t* dl=getDataline(env,obj);
	unsigned int captureChannels;
	int ret=snd_pcm_hw_params_get_channels(dl->hw_params,&captureChannels);
	unsigned int channels=dl->channels;
	if(ret<0){

		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/io/IOException"),(const char*)"Cannot get channel count.");
		return 0;
	}
	int captureLen=len*captureChannels/channels;
	if(captureChannels!=channels){
		// dynamic buffer increase
		if(dl->captureBuf==NULL){
			dl->captureBuf=malloc(captureLen);
			dl->captureBufLen=captureLen;
		}
		if(dl->captureBufLen<captureLen){
			free(dl->captureBuf);
			dl->captureBuf=malloc(captureLen);
			dl->captureBufLen=captureLen;
		}
		if(dl->captureBuf==NULL){
				fprintf(stderr,"Could not allocate buffer!");
				(*env)->ThrowNew(env,(*env)->FindClass(env,"java/io/IOException"),"Could not allocate ring buffer");
				return 0;
			}
	}
	if(dl->buf==NULL){
		dl->buf=malloc(len);
		dl->bufLen=len;
	}
	if(dl->bufLen<len){
		free(dl->buf);
		dl->buf=malloc(len);
		dl->bufLen=len;
	}
	if(dl->buf==NULL){
		fprintf(stderr,"Could not allocate buffer!");
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/io/IOException"),"Could not allocate ring buffer");
		return 0;
	}
	int lenCaptureFrames=len/dl->frameSize;
	snd_pcm_sframes_t readFrames=0;
	if(lenCaptureFrames>0){
		if(captureChannels!=channels){
			int sampleSize=dl->frameSize/channels;
			int captureFrameSize=sampleSize*captureChannels;
			if(DEBUG>4){
													printf("Capture chs %d captureFrameSize %d\n",captureChannels,captureFrameSize);
													fflush(stdout);
												}

			readFrames=snd_pcm_readi(dl->pcm, dl->captureBuf, lenCaptureFrames);
			//int readBytes=readFrames*dl->frameSize;
			if(DEBUG>4){
						printf("readi Frames: %ld to capture buf\n",readFrames);
						fflush(stdout);
					}

			int fp;
			for(fp=0;fp<readFrames;fp++){
				int captureBufPos=fp*captureFrameSize;
				int bufPos=fp*dl->frameSize;
				int sp;
				if(DEBUG>4){
										printf("Bufpos %d captureBufPos %d\n",bufPos,captureBufPos);
										fflush(stdout);
									}
				if(captureChannels>channels){
				for(sp=0;sp<dl->frameSize;sp++){
					((jbyte *)dl->buf)[bufPos+sp]=((jbyte *)dl->captureBuf)[captureBufPos+sp];
				}
				}else{

					// duplicate channels
					int factor=channels/captureChannels;
					int d;
					for(d=0;d<factor;d++){
					for(sp=0;sp<sampleSize;sp++){
							((jbyte *)dl->buf)[bufPos+sp+(sampleSize*d)]=((jbyte *)dl->captureBuf)[captureBufPos+sp];
					}
					}
				}
			}

		}else{
			readFrames=snd_pcm_readi(dl->pcm, dl->buf, lenCaptureFrames);
			if(DEBUG>4){
									printf("readi Frames to buf: %ld\n",readFrames);
									fflush(stdout);
								}
		}
		if(DEBUG>4){
			printf("read Frames: %ld\n",readFrames);
			fflush(stdout);
		}
		if(readFrames >0){
			read=readFrames*dl->frameSize;
			//jbyte *nBuf=dl->buf;
			(*env)->SetByteArrayRegion(env,buf,offset,read,dl->buf);
			dl->framesTransfered+=readFrames;
		}
	}
	if(DEBUG>4){
		printf("read: %d\n",read);
		fflush(stdout);
	}
	return read;
}



